package body ITI8590.Natural_Number_Multiplication is

   procedure Add_To(Value : in out Number; Summand : in Number) is
      Value_Index : Index := Value'First;
      Carry       : Digit := 0;
   begin
      for Summand_Index in Summand'Range loop
         declare
            Sum : Natural := Natural(Value(Value_Index)) +
                             Natural(Summand(Summand_Index)) +
                             Natural(Carry);
         begin
            Value(Value_Index) := Digit(Sum mod 2);
            Carry              := Digit(Sum / 2);
         end;
         Value_Index := Value_Index + 1;
      end loop;
      while Carry = 1 loop
         case Value(Value_Index) is
            when 0 => Value(Value_Index) := 1;
                      Carry := 0;
            when 1 => Value(Value_Index) := 0;
         end case;
         Value_Index := Value_Index + 1;
      end loop;
   end Add_To;

   procedure Standard(Factor_1, Factor_2 : in Number; Product : out Number) is
      Product_Index : Index := Product'First;
   begin
      Product := (others => 0);
      for Factor_1_Index in Factor_1'Range loop
         if Factor_1(Factor_1_Index) = 1 then
            Add_To(Product(Product_Index .. Product'Last), Factor_2);
         end if;
         Product_Index := Product_Index + 1;
      end loop;
   end Standard;

end ITI8590.Natural_Number_Multiplication;
